
classdef RastriginReward < Environments.EpisodicContextualParameterLearningTask
    
    properties

        rewardCenter = 0;
        rewardDistance = 0;
        
    end
    
    properties (SetObservable, AbortSet)
        rewardNoise = 0;
        rewardNoiseMult = 0;
    end
    
    methods
        function obj = RastriginReward(episodeSampler, dimContext, dimParameters)
            obj = obj@Environments.EpisodicContextualParameterLearningTask(episodeSampler, dimContext, dimParameters);
           
            
            obj.dataManager.setRange('contexts', ones(1, dimContext) * - 10, ones(1, dimContext) * 10);

            obj.dataManager.setRange('parameters', ones(1, dimParameters) * -50, ones(1, dimParameters) * 50);    
            
            obj.linkProperty('rewardNoise');
    
        end
        
        function [reward] = sampleReturn(obj, contexts, parameters)
            
            x = [contexts, parameters];
            

             [P,N] = size(x);
             scale=10.^((0:N-1)'/(N-1));
             scale=repmat(scale',P,1);
             reward = 10*N + sum((scale.*x).^2 - 10*cos(2*pi.*(scale.*x)),2);
  
            
            
            reward = -1.*reward;
            
        end
        
    end
    
end

