
classdef SphereReward < Environments.EpisodicContextualParameterLearningTask
    
    properties

        rewardCenter = 0;
        rewardDistance = 0;
        
    end
    
    properties (SetObservable, AbortSet)
        rewardNoise = 0;
        rewardNoiseMult = 0;
    end
    
    methods
        function obj = SphereReward(episodeSampler, dimContext, dimParameters)
            obj = obj@Environments.EpisodicContextualParameterLearningTask(episodeSampler, dimContext, dimParameters);
           
            
            obj.dataManager.setRange('contexts', ones(1, dimContext) * - 10, ones(1, dimContext) * 10);
            obj.dataManager.setRange('parameters', ones(1, dimParameters) * - 10, ones(1, dimParameters) * 10);    
            
            obj.linkProperty('rewardNoise');
    
        end
        
        function [reward] = sampleReturn(obj, contexts, parameters)
            
            sample = [contexts, parameters];
            reward =sum(sample.^2,2);
            reward = -1.*reward;
            
        end
        
    end
    
end

